#include <Servo.h>

Servo First;
Servo Second;
Servo Third;
Servo Four;

Servo Grapper;

unsigned long time;

void setup() {
  // put your setup code here, to run once:
  First.attach(5);
  Second.attach(6);
  Third.attach(9);
  Four.attach(10);
  Grapper.attach(3);
  time = millis();
  Serial.begin(115200);
  while (!Serial) {}
}

bool first = false;

float currposa = 90;
float currposb = 90;
float currposc = 90;
float currposd = 90;
float currpose = 90;
float targetposa = 90;
float targetposb = 90;
float targetposc = 90;
float targetposd = 90;
float targetpose = 90;

float LinearCalc(float base,float dest, float procent)
{
  return base + ( dest - base ) * procent;
}

float procent = 0;
int val = 1;

bool once = false;

void loop() {
  if( millis() - time > 10 )
  {
    procent += 0.01f/(float)val;
    if( procent >= 1 )
    {
      currposa=targetposa;
      currposb=targetposb;
      currposc=targetposc;
      currposd=targetposd;
      currpose=targetpose;
      procent = 1;
      if( !once )
      {
        once = true;
        Serial.write("OK");
        Serial.flush();
      }
    }
  }
  
  First.write  (LinearCalc(currposa,targetposa,procent));
  Second.write (LinearCalc(currposb,targetposb,procent));
  Third.write  (LinearCalc(currposc,targetposc,procent));
  Four.write   (LinearCalc(currposd,targetposd,procent));
  Grapper.write(LinearCalc(currpose,targetpose,procent));
  if( Serial.available() >= 5 )
  {
    procent = 0;
    once = false;
    targetposa = Serial.read();
    targetposb = Serial.read();
    targetposc = Serial.read();
    targetposd = Serial.read();
    targetpose = Serial.read();
    currposa = LinearCalc(currposa,targetposa,procent);
    currposb = LinearCalc(currposb,targetposb,procent);
    currposc = LinearCalc(currposc,targetposc,procent);
    currposd = LinearCalc(currposd,targetposd,procent);
    currpose = LinearCalc(currpose,targetpose,procent);
    //calc speed 1 degre per sec
    val = abs(currposa - targetposa);
    if( val < abs(currposb - targetposb) )
        val = abs(currposb - targetposb);
    if( val < abs(currposc - targetposc) )
        val = abs(currposc - targetposc);
    if( val < abs(currposd - targetposd) )
        val = abs(currposd - targetposd);
    if( val < abs(currpose - targetpose) )
        val = abs(currpose - targetpose);
    while( Serial.available() > 0 )
      Serial.read();
  }
}



